#ifndef __JOSH_CUSTOM_ASSERT_H
#define __JOSH_CUSTOM_ASSERT_H

namespace Assert
  {
    typedef enum
      {
        Break,
        Skip,
        SkipAlways
      } AssertResult;
    typedef AssertResult (*AssertFunction)(const char *file, unsigned line, const char *expr);
    extern AssertFunction gAssertFunction;
  };

#ifndef NDEBUG

#if defined (__WATCOM_CPLUSPLUS__)
namespace Assert
  {
    void DebuggerBreakpointInternal();
#pragma aux DebuggerBreakpointInternal = "int 3" modify [];
  }
#define _ASSERT_BREAK Assert::DebuggerBreakpointInternal();
#elif defined(_MSC_VER)
#define _ASSERT_BREAK __asm int 3
#else
#error assert.h needs to be ported to a new compiler
#endif

#define assert(EXPR) \
  do { static bool _skip_assert_always_ = false; \
    if (! _skip_assert_always_ && ! (EXPR)) \
      { if (Assert::gAssertFunction) \
          { Assert::AssertResult result = \
              (*Assert::gAssertFunction)(__FILE__, __LINE__, #EXPR); \
            if (result==Assert::SkipAlways) \
              _skip_assert_always_=true; \
            else if (result==Assert::Skip) \
              ; \
            else /* (result==Assert::Break) */ \
              _ASSERT_BREAK \
          } \
        else \
          _ASSERT_BREAK \
    } } while(0)

#else
#define assert(EXPR)
#endif

#endif /* __JOSH_CUSTOM_ASSERT_H */