#ifndef JIGSAW_PUZZLE_H
#define JIGSAW_PUZZLE_H

#include "root2d.h"
#include <list>
#include <hash_map>

class Puzzle
  {
protected:
    typedef std::list<int> PuzzleCornerList;
    typedef PuzzleCornerList::iterator PuzzleCornerIter;

    struct PuzzleSide
      {
        int mSide;
        int mNeighbor;
        PuzzleCornerIter mCorners[2];
      };

    typedef std::list<PuzzleSide>    PuzzleSideList;
    typedef PuzzleSideList::iterator PuzzleSideIter;

    typedef std::hash_map<int, PuzzleSideList> PuzzleInfo;
    typedef PuzzleInfo::iterator               PuzzleIter;

    int mCurNumber;
    ScalarType mEpsilon;
    PuzzleInfo mPuzzle;
    PuzzleCornerList mPuzzleCorners;
public:
    typedef Root2D::Contour ContourType;
    typedef std::list<ContourType> ContourList;

    explicit Puzzle(ScalarType epsilon) 
      : mEpsilon(epsilon), mCurNumber(8) { }

    void AddPiece(ContourList &results, int id, int numcorners, 
                  int *neighbors, ContourList &toadd, 
                  DomainType2d *cornerlocs);
    void FinishPuzzle(ContourList &results);
  };

#endif